using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.ProgramManager.Cqrs;

public record DeleteProgramManagerCommand(string Id) : IRequest<bool>;

public class DeleteProgramManagerHandler : IRequestHandler<DeleteProgramManagerCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteProgramManagerHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteProgramManagerCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.ProgramManager
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.ProgramManager.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}